local addonName, addon = ...
AvengersNemesis = addon
SLASH_AVENGERSNEM1 = "/avn"
local avnMainFrameX = 300
local avnMainFrameY = 300
local avnMainFrameW = 335
local avnMainFrameH = 420
local numRaces = 7
local avnSubFrameNum = 8
local myName = GetUnitName("player", true)
local groups = {}
local factionGroup, factionName = UnitFactionGroup("player")
if factionGroup == 'Alliance' then
  groups = {"Orc","Blood Elf","Troll","Tauren","Goblin","Undead","Panda","None"}
elseif factionGroup == 'Horde' then
  groups = {"Human","Dwarf","Night Elf","Gnome","Worgen","Draenei","Panda","None"}
end

local mt
local AVN_mainFrame = {}
local AVN_subFrame = {}
--local AVN_textFrame = {}
local ROW_HEIGHT = 14
local MAX_ROWS = 5   

local function printGroupsToRW()
 local rw = "|| "
 for i=1,numRaces do
  rw = rw..i..string.char(58).." "..groups[i].." || "
 end
 SendChatMessage("Avengers Nemesis Groups:", "RAID_WARNING")
 SendChatMessage("To be placed in a group, whisper "..myName.." with 'avn #' (eg: avn 4)", "RAID_WARNING")
 SendChatMessage(rw, "RAID_WARNING")
 SendChatMessage("For help whisper me 'avn ?'", "RAID_WARNING")
end

function addon:colorUnit(unit)
  local _,class = UnitClass(unit)
  local color = class and RAID_CLASS_COLORS[class]
  color = color and color.colorStr
  color = color or "ffcfcfcf"
  return "\124c"..color..unit.."\124r"
end

local function setAVNframeText()
 for group = 1, avnSubFrameNum do
   AVN_subFrame[group]:Update()
  end
end

local function clearAVNdata(alwaysshow)
    StaticPopupDialogs["AVN_PROMPTFORRESET"] = StaticPopupDialogs["AVN_PROMPTFORRESET"] or {
      text = "Do you want to clear the AVN data?",
      button1 = "Yes",
      button2 = "No",
      OnAccept = function()
        mt = {}
        setAVNframeText()
      end,
      OnCancel = function()
      end,
      timeout = 0,
      whileDead = true,
      hideOnEscape = true,
      preferredIndex = 3,
    }
    local now = GetTime()
    if now < (addon.lastclearprompt or 0)+5*60 and not alwaysshow then return end -- don't spam messages
    addon.lastclearprompt = now
    StaticPopup_Show ("AVN_PROMPTFORRESET")
end

local function ToggleDock()
  addon.docked = not addon.docked
  addon.dockbutton:SetText(addon.docked and "Undock" or "Dock")
  if addon.docked then
    OpenFriendsFrame(4)
    AVN_mainFrame:SetFrameLevel(RaidFrame:GetFrameLevel()+10)
  end
  hookRaidFrame()
end
function hookRaidFrame()
  if not RaidFrame then return end
  if addon.raidhooked then return end
  if IsAddOnLoaded("Blizzard_RaidUI") then
    addon.raidhooked = true
  end
  RaidFrame:HookScript("OnShow", function()
    if addon.docked and addon:shouldIshow(false) then
      AVN_mainFrame:Show()
    end
  end)
  RaidFrame:HookScript("OnHide", function()
    if addon.docked then
      AVN_mainFrame:Hide()
    end
  end)
end
hookRaidFrame()

local contextFrame = CreateFrame("Frame", "AVNUserContextFrame", UIParent, "UIDropDownMenuTemplate")
local contextRow
local contextMenu = {
    { text = "Title", isTitle = true},
    { text = "Whisper", func = function() ChatFrame_SendTell(contextRow.name) end },
    { text = "Send Help", func = function() addon:sendHelpFile(contextRow.name) end },
    { text = "Add to Queue", hasArrow = true,
        menuList = { } -- filled in below
    },
    { text = "Remove from Queue", func = function() addon:removeFromGroup(contextRow.name, true, true) end },
    { text = "Close", func = function() contextFrame:Hide() end },
}
for i=1,numRaces do
  contextMenu[4].menuList[i] = 
     { text = string.format("%d: %s",i,groups[i]), 
       func = function() 
	 contextFrame:Hide() -- hide top-level menu
         addon:addToGroup(contextRow.name, i, true)
       end }
end
local function Row_OnClick(self)
  contextRow = self
  --print("Context menu: "..contextRow.name)
  contextMenu[1].text = self:GetText()
  contextFrame:Show()
  EasyMenu(contextMenu, contextFrame, "cursor", 0 , 0, "MENU", 10)
end

local function drawAvnMainFrame()
    AVN_mainFrame = CreateFrame("Frame", "AVN_MainFrame", UIParent)
    AVN_mainFrame:SetMovable(true)
    AVN_mainFrame:EnableMouse(true)
    AVN_mainFrame:RegisterForDrag("LeftButton")
    AVN_mainFrame:SetScript("OnDragStart", AVN_mainFrame.StartMoving)
    AVN_mainFrame:SetScript("OnDragStop", AVN_mainFrame.StopMovingOrSizing)
    AVN_mainFrame:SetSize(avnMainFrameW,avnMainFrameH)
    AVN_mainFrame:SetClampedToScreen(true)
    AVN_mainFrame:SetPoint("TOPLEFT",400,-130)
    AVN_mainFrame.backGround=AVN_mainFrame:CreateTexture("AVN_mainFrame_backGround","BACKGROUND")
    AVN_mainFrame.backGround:SetSize(avnMainFrameW,avnMainFrameH)
    AVN_mainFrame.backGround:SetPoint("CENTER")
    AVN_mainFrame.backGround:SetTexture(0,0,0,.5)
    AVN_mainFrame.title = AVN_mainFrame:CreateFontString(AVN_mainFrame_Title, "OVERLAY", "GameFontNormal")
    AVN_mainFrame.title:SetPoint("TOP", 0, -4)
    AVN_mainFrame.title:SetText("Avengers Nemesis Groups")

    local buttonBackdrop = {bgFile = "Interface/Tooltips/UI-Tooltip-Background", 
        edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
        tile = true, tileSize = 16, edgeSize = 16, 
        insets = { left = 4, right = 4, top = 4, bottom = 4 }}

    local closeFrame = CreateFrame("Button", nil, AVN_mainFrame)
    closeFrame:SetSize(22, 20)
    closeFrame:SetNormalFontObject(GameFontHighlightCenter)
    closeFrame:SetPoint("CENTER", AVN_mainFrame, "TOPRIGHT", -13, -12)
    closeFrame:SetText("X")
    closeFrame:SetBackdrop(buttonBackdrop)
    closeFrame:SetBackdropColor(1,0,0,1);
    closeFrame:SetScript("OnClick", function(self, arg1)
      AVN_mainFrame:Hide()
    end)

    local printRaid = CreateFrame("Button", nil, AVN_mainFrame)
    printRaid:SetSize(40, 20)
    printRaid:SetNormalFontObject(GameFontHighlightCenter)
    printRaid:SetPoint("CENTER", AVN_mainFrame, "BOTTOMRIGHT", -22, 12)
    printRaid:SetText("RW")
    printRaid:SetBackdrop(buttonBackdrop)
    printRaid:SetBackdropColor(0,0,0,.3);
    printRaid:SetScript("OnClick", function(self, arg1)
      printGroupsToRW()
    end)

    local clearData = CreateFrame("Button", nil, AVN_mainFrame)
    clearData:SetSize(75, 20)
    clearData:SetNormalFontObject(GameFontHighlightCenter)
    clearData:SetPoint("CENTER", AVN_mainFrame, "BOTTOMLEFT", 40, 12)
    clearData:SetText("Clear Data")
    clearData:SetBackdrop(buttonBackdrop)
    clearData:SetBackdropColor(0,0,0,.3);
    clearData:SetScript("OnClick", function(self, arg1)
      clearAVNdata(true)
    end)

    local dock = CreateFrame("Button", nil, AVN_mainFrame)
    addon.dockbutton = dock
    dock:SetSize(55, 20)
    dock:SetNormalFontObject(GameFontHighlightCenter)
    dock:SetPoint("CENTER", AVN_mainFrame, "TOPLEFT", 30, -12)
    dock:SetText("Dock")
    dock:SetBackdrop(buttonBackdrop)
    dock:SetBackdropColor(0,0,0,.3);
    dock:SetScript("OnClick", ToggleDock)

--    AVN_mainFrame:Show()
    AVN_mainFrame:Hide()
end
local function drawAvnSubBoxes()
    local boxW = 150
    local boxH = 71
    local spacer = 20

    for i = 1, avnSubFrameNum do
        AVN_subFrame[i] = CreateFrame("Frame", "AVN_MainFrame", AVN_mainFrame)
        AVN_subFrame[i]:SetSize(boxW, boxH)
        if i == 1 then
            AVN_subFrame[i]:SetPoint("TOPLEFT", 15, -45)
        elseif i == 3 or i == 5 or i == 7 then
            AVN_subFrame[i]:SetPoint("TOPLEFT", AVN_subFrame[i-2], "BOTTOMLEFT", 0, -spacer)
        else
            AVN_subFrame[i]:SetPoint("TOPLEFT", AVN_subFrame[i-1], "TOPRIGHT", 15, 0)
        end
        AVN_subFrame[i].backGround=AVN_subFrame[i]:CreateTexture("AVN_subFrame_backGround","BACKGROUND")
        AVN_subFrame[i].backGround:SetSize(boxW, boxH)
        AVN_subFrame[i].backGround:SetPoint("CENTER")
        AVN_subFrame[i].backGround:SetTexture(1,1,1,.2)
        AVN_subFrame[i].title = AVN_subFrame[i]:CreateFontString(AVN_subFrame_Title, "OVERLAY", "GameFontNormal")
        AVN_subFrame[i].title:SetPoint("TOPLEFT", -10, 14)
        AVN_subFrame[i].title:SetText(i.." "..groups[i])

        local bar = CreateFrame("ScrollFrame", "$parentScrollBar"..i, AVN_subFrame[i], "FauxScrollFrameTemplate")
        bar:SetPoint("TOPLEFT", 0, -1)
        bar:SetPoint("BOTTOMRIGHT", -23, 1)
        bar:SetScript("OnVerticalScroll", function(self, offset)
          self.offset = math.floor(offset / ROW_HEIGHT + 0.5)
          AVN_subFrame[i]:Update()
        end)
        bar:SetScript("OnShow", function()
        	AVN_subFrame[i]:Update()
        end)
        AVN_subFrame[i].scrollBar = bar

        AVN_subFrame[i].Update = function()
	  AVN_subFrame[i].data = addon:getSortedMembers(i, AVN_subFrame[i].data)
          local myGroupData = AVN_subFrame[i].data
	  local count = #myGroupData
          FauxScrollFrame_Update(AVN_subFrame[i].scrollBar, count, MAX_ROWS, ROW_HEIGHT)
          local offset = FauxScrollFrame_GetOffset(AVN_subFrame[i].scrollBar)
          for j = 1, MAX_ROWS do
            local row = AVN_subFrame[i].rows[j]
            local id = j + offset
            if id <= count then
	      local name = myGroupData[id]
	      local text = addon:colorUnit(name)
	      local curgroup = addon.groupcache and addon.groupcache[name]

	      if IsInRaid() then
	        if not UnitIsConnected(name) then -- disconnected
	          row.highlight:SetTexture(0,0,0,0.4)
		  text = "(DC)"..text
	        elseif not UnitInRaid(name) then -- not in raid, should never happen
	          row.highlight:SetTexture(0,0,0,0.7)
	        elseif curgroup and curgroup ~= i then -- unit not in correct group
	          row.highlight:SetTexture(1,0,0,0.5)
	          text = "("..curgroup..")"..text
		else -- normal
	          row.highlight:SetTexture(0,0,0,0)
	        end
	      end
              row:SetText(text)
	      row.name = name
              row:Show()
            else
              row:Hide()
            end
          end
        end

        local rows = setmetatable({}, { __index = function(t, j)
	    local row = CreateFrame("Button", "$parentRow"..i, AVN_subFrame[i])
            row:SetSize(146, ROW_HEIGHT)
            row:SetNormalFontObject(GameFontHighlightLeft)
	    row.highlight = row:CreateTexture(nil,"BACKGROUND")
	    row.highlight:SetSize(row:GetSize())
	    row.highlight:SetPoint("CENTER")
	    row.highlight:SetTexture(0,0,0,0)
	    row.highlight:Show()
            if j == 1 then
                row:SetPoint("TOPLEFT", AVN_subFrame[i], 2, -2)
            else
                row:SetPoint("TOPLEFT", AVN_subFrame[i].rows[j-1], "BOTTOMLEFT")
            end
	    row:SetScript("OnClick", Row_OnClick)
	    row:RegisterForClicks("AnyDown")
            rawset(t, j, row)
            return row
        end })
        AVN_subFrame[i].rows = rows

        AVN_subFrame[i]:Show()
    end
end

function addon:getSortedMembers(group, tableopt)
 local t = wipe(tableopt or {})
 for name,info in pairs(mt) do
  if info[1] == group then
   table.insert(t, name)
  end
 end
 addon.sortMemFunc = addon.sortMemFunc or function(a,b) return mt[a][2] < mt[b][2] end
 table.sort(t, addon.sortMemFunc)
 return t
end

function addon:getMembersOfGroup(group)
 local rText = ""
 local sortedKeys = addon:getSortedMembers(group)
 for _, key in ipairs(sortedKeys) do
  rText = rText..addon:colorUnit(key).."\n" 
 end
 return rText
end

function addon:addToGroup(name, group, quiet)
 name = name:gsub("%s*-%s*"..GetRealmName(),"") -- strip realm for same-realm
 if UnitInRaid(name) then
  local old = mt[name]
  if old and old[1] == group then -- already in that group, don't lose timestamp
    if not quiet then
       SendChatMessage("You are already in queue for group "..group.."-"..groups[group], "WHISPER", nil, name)
    end
    return
  end
  mt[name] = {group, time()}
  if not quiet then
   SendChatMessage("You have been added to the queue for group "..group.."-"..groups[group], "WHISPER", nil, name)
   SendChatMessage("Please whisper me with 'avn remove' when you have finished your quest or will be leaving the raid to make room for the next person in queue.", "WHISPER", nil, name)
  end
  setAVNframeText()
 else
  if not quiet then
   SendChatMessage("You are not in my raid. Please verify that you are sending your Nemesis group request to the correct person. If you sent this to me to be funny... ha... ha... ha...", "WHISPER", nil, name)
  end
 end
end

function addon:removeFromGroup(name, reload, quiet)
 name = name:gsub("%s*-%s*"..GetRealmName(),"") -- strip realm for same-realm
 if mt[name] then
  local group = mt[name][1]
  mt[name] = nil
  if not quiet then
   SendChatMessage("You have been removed from the Nemesis Group queue. Thank you for joining Avengers Nemesis. Please come again.", "WHISPER", nil, name)
  end
  if reload then
   setAVNframeText()
  end
 else
  if not quiet then
   SendChatMessage("You are not currently queued for a group.", "WHISPER", nil, name)
  end
 end
end

local function checkGroup(name)
 if mt[name] ~= nil then
  SendChatMessage("You are in queue for group "..mt[name][1].."-"..groups[mt[name][1]], "WHISPER", nil, name)
 else
  SendChatMessage("You are currently not in a Nemesis Group", "WHISPER", nil, name)
 end
end

local function getCountOfGroup(group, name)
 local count = 0
 for k,v in pairs(mt) do
  if v[1] == group then
   count = count + 1
  end
 end
 SendChatMessage(group..": "..groups[group].." - Total Current Members: "..count, "WHISPER", nil, name)
end

function addon:getGroupReport()
  local count = {}
  for name,info in pairs(mt) do
    local group = info[1] or 0
    count[group] = (count[group] or 0) + 1
  end
  local str = ""
  for i=1,numRaces do
    str = str..string.format("%s%s: %d", (#str>0 and ", " or ""), groups[i], count[i] or 0)
  end
  return "Nemesis group counts: "..str
end

function addon:sendHelpFile(name)
 SendChatMessage("Avengers Nemesis Groups Help:", "WHISPER", nil, name)
 SendChatMessage("'avn #' - Adds you to Nemesis group #", "WHISPER", nil, name)
 SendChatMessage("'avn list' - Replies with Races with group number", "WHISPER", nil, name)
 SendChatMessage("'avn check' - Replies with which group you are in", "WHISPER", nil, name)
 SendChatMessage("'avn count #' - Replies with how many people in Nemesis group #", "WHISPER", nil, name)
 SendChatMessage("'avn report' - Replies with a Nemesis group report", "WHISPER", nil, name)
 SendChatMessage("'avn remove' - Removes you from all Nemesis groups", "WHISPER", nil, name)
 SendChatMessage("'avn ?' - Replies with this information", "WHISPER", nil, name)
end

function addon:shouldIshow(output)
 if IsInRaid() then
  local name, rank, subgroup, level, class, fileName, zone, online, isDead, role, isML = GetRaidRosterInfo(UnitInRaid("player"))
  if rank > 0 then
   return true
  else
   if output then
    print("You are currently not in or raid or do not have assist")
   end
  end
 else
  if output then
   print("You are currently not in or raid or do not have assist")
  end
  return false
 end
end

function addon:scanGroups() -- populate groupcache with current party information
  if not IsInRaid() then return end
  addon.groupcache = wipe(addon.groupcache or {})
  for i=1,GetNumGroupMembers() do
    local name, rank, subgroup, level, class, fileName, zone, online, isDead, role, isML = GetRaidRosterInfo(i)
    addon.groupcache[name] = subgroup
  end 
end

local function raidChangedCheckRoster()
  if not addon:shouldIshow(false) and next(mt) ~= nil then
    clearAVNdata()
    AVN_mainFrame:Hide()
  else
    for name,v in pairs(mt) do
      if not UnitInRaid(name) then
        addon:removeFromGroup(name, true, false)
      end
    end
  end
end

local function tellMeGroups(name)
 local rw = "|| "
 for i=1,#groups do
  rw = rw..i..string.char(58).." "..groups[i].." || "
 end
 SendChatMessage(rw, "WHISPER", nil, name)
end

local function getCommandType(msg, name)
 local msg1, sep, msg2 = msg:match('^%s*(%a%a%a)([%s%p]*)(.-)%s*$')
 if msg1 and msg2 and msg1:lower() == 'avn' then
  local comm, rest = msg2:match("^(%S*)%s*(.-)$")
  comm = comm and comm:lower()
  if string.match(comm, "^[1-8]$") then
   local group = tonumber(comm)
   addon:addToGroup(name, group, false)
  elseif comm == "list" then
   tellMeGroups(name)
  elseif comm == "check" then
   checkGroup(name)
  elseif comm == "count" then
   if string.match(rest, "^[1-8]$") then
    getCountOfGroup(tonumber(rest), name)
   else
    SendChatMessage("* AVN:Invalid request. Please reply with 'avn ?' for help.", "WHISPER", nil, name)
   end
  elseif comm == "report" then
    local str = addon:getGroupReport()
    SendChatMessage(str, "WHISPER", nil, name)
  elseif comm == "remove" then
   addon:removeFromGroup(name, true, false)
  elseif sep:trim() == "?" or comm == "help" then
   addon:sendHelpFile(name)
  else
   SendChatMessage("* AVN:Invalid request. Please reply with 'avn ?' for help.", "WHISPER", nil, name)
  end  
 end
end

local function innitalizeAVN()
    drawAvnMainFrame()
end

innitalizeAVN()
drawAvnSubBoxes()
addon:scanGroups()

AVN_mainFrame:RegisterEvent("VARIABLES_LOADED")
AVN_mainFrame:RegisterEvent("ADDON_LOADED")
AVN_mainFrame:RegisterEvent("CHAT_MSG_WHISPER")
AVN_mainFrame:RegisterEvent("PLAYER_LOGOUT")
AVN_mainFrame:RegisterEvent("GROUP_ROSTER_UPDATE")
AVN_mainFrame:RegisterEvent("PLAYER_ENTERING_WORLD")

function AVN_mainFrame:OnEvent(event, ...)
 local arg1, arg2 = ...
 if event == "ADDON_LOADED" and arg1 == "AvengersNemesis" then
  if AvengersNemesisCache == nil then
   mt = {}
   --print("AVG: no cache")
  else
   mt = AvengersNemesisCache
   --print("AVG: Got data cache")
  end
  setAVNframeText()
 elseif event == "PLAYER_LOGOUT" then
  AvengersNemesisCache = mt
 elseif event == "CHAT_MSG_WHISPER" then
  if addon:shouldIshow(false) then
   local a,b,c,d,e,f,g,h,i,j,k,l = ...
   getCommandType(a, b)
  elseif arg1 and arg1:match("^%s*[aA][vV][nN]") then
   SendChatMessage("I am not leading Nemesis Groups in this Avengers group", "WHISPER", nil, arg2)
  end
 elseif event == "GROUP_ROSTER_UPDATE" then
  raidChangedCheckRoster()
  addon:scanGroups()
  setAVNframeText()
 end
end
AVN_mainFrame:SetScript("OnEvent", AVN_mainFrame.OnEvent)

local function printAVNslashCommands()
 print("Avengers Nemesis Help:")
 print("/avn show - Show GUI")
 print("/avn hide - Hide GUI")
 print("/avn add # - Adds Target to group #")
 print("/avn remove - Removes Target from group")
 print("/avn count # - Replies with count of that group")
 print("/avn rw - Prints Raid Warning")
 print("/avn report - Send group report to raid")
 print("/avn clear - Clears all groups")
 print("/avn demo - Displays AVN frame regardless of raid state")
 print("/avn print - Prints queue array to main chat window")
 print("/avn help - Sends help file @Target")
 print("/avn ? - Displays this help file")
end
-- Slash Commands
local function displayAVNbox(msg, editbox)
    local command, rest = msg:match("^(%S*)%s*(.-)$")
    command = command and command:lower()
    if command == 'show' then
      if addon:shouldIshow(true) then
        AVN_mainFrame:Show()
      end
    elseif command == 'hide' then
        AVN_mainFrame:Hide()
    elseif command == 'add' and rest ~= "" then
      local who = ""
      if UnitExists("target") then
        who = GetUnitName("target", true)
      else
        who = myName
      end
      addon:addToGroup(who, tonumber(rest), true)
    elseif command == 'remove' then
      if UnitExists("target") then
        addon:removeFromGroup(GetUnitName("target", true), true, true)
      end
    elseif command == 'count' and rest ~= "" then
      if string.match(rest, "^[1-8]$") then
        getCountOfGroup(tonumber(rest), myName)
      end
    elseif command == 'report' then
      local str = addon:getGroupReport()
      if IsInGroup(LE_PARTY_CATEGORY_INSTANCE) then
        SendChatMessage(str,"INSTANCE_CHAT")
      elseif IsInRaid() then
        SendChatMessage(str,"RAID")
      elseif IsInGroup() then
        SendChatMessage(str,"PARTY")
      else
        print(str)
      end
    elseif command == 'rw' then
        printGroupsToRW()
    elseif command == 'clear' then
        mt = {}
        setAVNframeText()
    elseif command == "demo" then
        AVN_mainFrame:Show()
    elseif command == "print" then
        for key,v in pairs(mt) do
          print(addon:colorUnit(key).." "..v[1].." "..v[2])
        end
    elseif command == "help" then
      if UnitExists("target") then
        addon:sendHelpFile(GetUnitName("target", true))
      end
    elseif command == "list" then
     tellMeGroups(GetUnitName("player", true))
    else
        --print(command.."|"..rest)
        printAVNslashCommands()
    end
end
SlashCmdList["AVENGERSNEM"] = displayAVNbox

